#include "header.h"

using namespace std;
using namespace GiNaC;

// when x is negative, i change sign of x and of the indices, 
// but the indices signs stay the same.
// Positive imaginary part in the variable corresponds to opposite-sign 
// imaginary part int the indices.
// Negative imaginary part in the variable corresponds to same-sign
// imaginary part in the indices.

ex FF(ex a1, ex a2, ex a3, ex a4, ex x){
	ex FF;
        if(a4!=0){
            if(x>=0){
                FF = G(lst(a1,a2,a3,a4),lst(-a1,-a2,-a3,-a4),x).evalf();
	    } else {
	  	FF = G(lst(-a1,-a2,-a3,-a4),lst(-a1,-a2,-a3,-a4),-x).evalf();
            }
	} else {
            if(x>=0){
                FF = conjugate(G(lst(a1,a2,a3,a4),lst(-a1,-a2,-a3,-a4),x)).evalf();
	    } else {
	  	FF = conjugate(G(lst(-a1,-a2,-a3,-a4),lst(-a1,-a2,-a3,-a4),-x)).evalf();
	    }
        }
	return FF;   
}
ex FF(ex a1, ex a2, ex a3,  ex x){
	ex FF;
        if(a3!=0){
	    if(x>=0){
	    	    FF = G(lst(a1,a2,a3),lst(-a1,-a2,-a3),x).evalf();
	    } else {
		    FF = G(lst(-a1,-a2,-a3),lst(-a1,-a2,-a3),-x).evalf();
	    }
        } else {
	    if(x>=0){
	    	    FF = conjugate(G(lst(a1,a2,a3),lst(-a1,-a2,-a3),x)).evalf();
	    } else {
		    FF = conjugate(G(lst(-a1,-a2,-a3),lst(-a1,-a2,-a3),-x)).evalf();
	    }
        }
	return FF;   
}
ex FF(ex a1, ex a2,  ex x){
	ex FF;
        if(a2!=0){
	    if(x>=0){
		    FF = G(lst(a1,a2),lst(-a1,-a2),x).evalf();
	    } else {
		    FF = G(lst(-a1,-a2),lst(-a1,-a2),-x).evalf();
	    }
        } else {
	    if(x>=0){
		    FF = conjugate(G(lst(a1,a2),lst(-a1,-a2),x)).evalf();
	    } else {
		    FF = conjugate(G(lst(-a1,-a2),lst(-a1,-a2),-x)).evalf();
	    }
        }
	return FF;   
}
ex FF(ex a1, ex x){
	ex FF;
	if(x>=0){
		FF = G(lst(a1),lst(-a1),x).evalf();
	} else {
            if (a1!=0){ 
		FF = G(lst(-a1),lst(-a1),-x).evalf();
            } else {
                FF = G(lst(0),-x).evalf()+M_PI*I; 
	    }
        }
	return FF;  
}

ex GG(ex a1, ex a2, ex a3, ex a4, ex x){
	ex GG;
	if(x>=0){
		GG = G(lst(a1,a2,a3,a4),lst(a1,a2,a3,a4),x).evalf();
	} else {
		GG = G(lst(-a1,-a2,-a3,-a4),lst(a1,a2,a3,a4),-x).evalf();
	}
	return GG;   
}
ex GG(ex a1, ex a2, ex a3,  ex x){
	ex GG;
	if(x>=0){
		GG = G(lst(a1,a2,a3),lst(a1,a2,a3),x).evalf();
	} else {
		GG = G(lst(-a1,-a2,-a3),lst(a1,a2,a3),-x).evalf();
	}
	return GG;   
}
ex GG(ex a1, ex a2,  ex x){
	ex GG;
	if(x>=0){
		GG = G(lst(a1,a2),lst(a1,a2),x).evalf();
	} else {
		GG = G(lst(-a1,-a2),lst(a1,a2),-x).evalf();
	}
	return GG;   
}
ex GG(ex a1, ex x){
	ex GG;
	if(x>=0){
		GG = G(lst(a1),lst(a1),x).evalf();
	} else {
            if (a1!=0){ 
		GG = G(lst(-a1),lst(a1),-x).evalf();
            } else {
                GG = G(lst(0),-x).evalf()-M_PI*I; 
	    }
        }
	return GG;  
}

